﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Microsoft.Practices.Prism.Commands;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace XDGDoubleClickCommandCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }
     
        public DelegateCommand<object> MyRowSpecificCommand { get; set; }


        Random r = new Random();       
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i<15; i++)
            {
                Data.Add(new SampleData()
                {
                    ID = i,
                    Label = "Label " + i.ToString(),
                    Number = r.Next(1000)
                });
            }

            MyRowSpecificCommand = new DelegateCommand<object>(MyRowSpecificCommand_Execute);
        }

        public void MyRowSpecificCommand_Execute(object obj)
        {
            MouseButtonEventArgs args = obj as MouseButtonEventArgs;
            if(args != null)
            {
                if(args.ClickCount == 2)
                {
                    DataRecordPresenter drp = null;
                    if (args.Source is DataRecordPresenter)
                    {
                        drp = args.Source as DataRecordPresenter;
                    }
                    else
                    {
                        drp = Utilities.GetAncestorFromType(args.Source as DependencyObject, typeof(DataRecordPresenter), false) as DataRecordPresenter;
                    }

                    if(drp != null)
                    {
                        DataRecord record = drp.Record as DataRecord;
                    }                    
                }
            }
        }     
    }

    public class SampleData
    {
        public int ID { get; set; }
        public string Label { get; set; }
        public int Number { get; set; }
    }
}
